<template>
	<div class="statistics-center-twist-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<el-form :model="state.queryParams" ref="ruleFormRef" @submit.native.prevent inline>
				<el-form-item prop="crTime">
					<statistical-time v-model="state.queryParams.crTime" @change="handleQuery" ref="statisticalTimeRef" :disabled="state.loading" />
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" class="default-button" :loading="state.loading">
						<SvgIcon name="ele-Refresh" class="mr5" />重置
					</el-button>
					<el-popover :width="500" trigger="click">
						<template #reference>
							<el-button type="primary" title="口径说明"><SvgIcon name="ele-QuestionFilled" class="mr5" />口径说明</el-button>
						</template>
						<el-descriptions title="" :column="1" border style="max-height: 400px; overflow: auto">
							<el-descriptions-item label="回访员">当前登录系统的坐席人员名称</el-descriptions-item>
							<el-descriptions-item label="部门扭转总件">部门待审批件+部门审批成功件+部门审批失败件</el-descriptions-item>
							<el-descriptions-item label="部门待审批件">部门扭转待评判工单数量</el-descriptions-item>
							<el-descriptions-item label="部门审批成功件">部门扭转评判同意的工单数量</el-descriptions-item>
							<el-descriptions-item label="部门审批失败件">部门扭转评判不同意的工单数量</el-descriptions-item>
							<el-descriptions-item label="坐席扭转总件">坐席待审批件+坐席审批成功件+坐席审批失败件</el-descriptions-item>
							<el-descriptions-item label="坐席待审批件">中心扭转待评判工单数量</el-descriptions-item>
							<el-descriptions-item label="坐席审批成功件">中心扭转评判同意的工单数量</el-descriptions-item>
							<el-descriptions-item label="坐席审批失败件">中心扭转评判不同意的工单数量</el-descriptions-item>
						</el-descriptions>
					</el-popover>
					<el-button type="primary" @click="onDetail('visit')" :loading="state.loading">
						<SvgIcon name="ele-PhoneFilled" class="mr5" /> 扭转回访明细
					</el-button>
					<el-button type="primary" @click="onDetail('department')" :loading="state.loading">
						<SvgIcon name="ele-List" class="mr5" /> 扭转部门明细
					</el-button>
					<el-button type="primary" @click="onDetail('seat')" :loading="state.loading">
						<SvgIcon name="ele-UserFilled" class="mr5" /> 扭转坐席明细
					</el-button>
				</el-form-item>
			</el-form>
			<vxe-toolbar
				ref="toolbarRef"
				:loading="state.loading"
				custom
				:refresh="{
					queryMethod: handleQuery,
				}"
				:tools="[{ toolRender: { name: 'exportAll' } }]"
			>
			</vxe-toolbar>
			<div style="overflow: hidden; width: 100%; height: 100%; flex: 1">
				<vxe-table
					border
					:loading="state.loading"
					:data="state.tableData"
					:column-config="{ resizable: true }"
					:row-config="{ isCurrent: true, isHover: true, height: 30,useKey: true }"
					ref="tableRef"
					height="auto"
					auto-resize
					show-overflow
					:scrollY="{ enabled: true, gt: 100 }"
					id="statisticsCenterTwist"
					:custom-config="{
						storage: true,
					}"
					showHeaderOverflow
					:params="{ exportMethod: centerTurnExport, exportParams: requestParams }"
					show-footer
					:footer-method="footerMethod"
				>
					<vxe-column field="empName" title="回访员"></vxe-column>
					<vxe-column field="orgJudeCount" title="部门扭转总件" sortable></vxe-column>
					<vxe-column field="orgJudeApprovalingCount" title="部门待审批件" sortable></vxe-column>
					<vxe-column field="orgJudeSuccessCount" title="部门审批成功件" sortable></vxe-column>
					<vxe-column field="orgJudeFailCount" title="部门审批失败件" sortable></vxe-column>
					<vxe-column field="seatJudeCount" title="坐席扭转总件" sortable></vxe-column>
					<vxe-column field="seatJudeApprovalingCount" title="坐席待审批件" sortable></vxe-column>
					<vxe-column field="seatJudeSuccessCount" title="坐席审批成功件" sortable></vxe-column>
					<vxe-column field="seatJudeFailCount" title="坐席审批失败件" sortable></vxe-column>
				</vxe-table>
			</div>
		</div>
	</div>
</template>
<script setup lang="tsx" name="statisticsCenterTwist">
import { defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { FormInstance } from 'element-plus';
import { centerTurn, centerTurnExport } from '@/api/statistics/center';
import { defaultDate } from '@/utils/constants';
import Other from '@/utils/other';
import { useRouter } from 'vue-router';
import XEUtils from 'xe-utils';

const StatisticalTime = defineAsyncComponent(() => import('@/components/StatisticalTime/index.vue')); // 日期类型选择组件
// 定义变量内容
const ruleFormRef = ref<RefType>(); // 表单ref
const state = reactive<any>({
	queryParams: {
		// 查询条件
		crTime: defaultDate, // 创建时间
		StartTime: null,
		EndTime: null,
	},
	tableData: [], //表单
	loading: false, // 加载
	totalCount: {}, // 总数
});
/** 搜索按钮操作 */
const handleQuery = () => {
	queryList();
};
/** 获取列表 */
const requestParams = ref<EmptyObjectType>({});
const queryList = () => {
	state.loading = true;
	requestParams.value = Other.deepClone(state.queryParams);
	requestParams.value.StartTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[0];
	requestParams.value.EndTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[1];
	Reflect.deleteProperty(requestParams.value, 'crTime');
	centerTurn(requestParams.value)
		.then((res: any) => {
			state.tableData = res.result ?? [];
			state.loading = false;
		})
		.catch(() => {
			state.loading = false;
		});
};
/** 重置按钮操作 */
const statisticalTimeRef = ref<RefType>();
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	statisticalTimeRef.value.reset();
	queryList();
};
// 查看详情
const router = useRouter();
const onDetail = (type: string) => {
	switch (type) {
		case 'visit':
			router.push({
				path: '/statistics/center/detailTwist',
				query: {
					tagsViewName: '扭转回访明细',
				},
			});
			break;
		case 'department':
			router.push({
				path: '/statistics/center/detailTwist',
				query: {
					tagsViewName: '扭转部门明细',
					type,
				},
			});
			break;
		case 'seat':
			router.push({
				path: '/statistics/center/detailTwist',
				query: {
					tagsViewName: '坐席回访明细',
					type,
				},
			});
			break;
	}
};
const footerMethod = ({ columns, data }) => {
	return [
		columns.map((column: any, columnIndex: number) => {
			if (columnIndex === 0) {
				return '合计';
			}
			if (
				[
					'orgJudeCount',
					'orgJudeApprovalingCount',
					'orgJudeSuccessCount',
					'orgJudeFailCount',
					'seatJudeCount',
					'seatJudeApprovalingCount',
					'seatJudeSuccessCount',
					'seatJudeFailCount',
				].includes(column.property)
			) {
				return XEUtils.sum(data, column.property);
			}
		}),
	];
};
const toolbarRef = ref<RefType>();
const tableRef = ref<RefType>();
onMounted(() => {
	queryList();
	if (tableRef.value && toolbarRef.value) {
		tableRef.value.connect(toolbarRef.value);
	}
});
</script>
